# linux-elphel
Extras (drivers, etc.) and patches for the kernel

##Downloading
Code must be located in `poky/` directory. Navigate to `poky/` and run:
```
git clone https://github.com/Elphel/linux-elphel.git
```
##Generating links and headers
Links between project tree and kernel source tree are generated by Bitbake during 'link' task when using `meta-elphel393`. Some required header files are automatically generated during the build process.
```
. ./oe-init-build-env
bitbake linux-xlnx -c clean -f
bitbake linux-xlnx -c link -f
bitbake linux-xlnx -f
```
##Importing project into Eclipse
Run Eclipse from its location directory and provide additional heap memory to it.
```
./eclipse -vmargs -Xmx4G
```
 - File → Import... → General → Existing Project into Workspace
 - [Next] → Select root directory → Browse → specify project location (`poky/linux-elphel/`) → [OK] → [Finish]

Project now is imported into Eclipse workspace.

 - Project → Properties
 - C/C++ General → Preprocessor Include Paths → Entries → GNU C → CDT User Settings
   - [Add...] → Select "Preprocessor macros file" → `linux/include/generated/autoconf.h` → [OK]
   - [Add...] → Select "Preprocessor macros file" → `linux/include/linux/compiler.h` → [OK]
   - [Add...] → Select "Include file" → `linux/include/linux/kconfig.h` → [OK]
 - C/C++ General → Indexer
   - Check “Enable project specific setttings”
   - Check “Enable indexer”
   - Uncheck “Index source files not included in the build”
   - Uncheck “Index unused headers”
   - Check “Index header variants”
   - Uncheck “Index source and header files opened in editor”
   - Uncheck “Allow heuristic resolution of includes”
   - Set size of files to be skipped >100MB (effectively disabling this feature)
   - Uncheck all “Skip…” options
 - [OK] to close the Advanced Settings window.
 - Project → C/C++ Index → Rebuild
